/*
 * BDF2BDB - BDF font data conveter
 * Release version 0.0.0
 * Copyright (c)2006 satoshi akabane
 * http://www.logical-paradox.org/
 *
 * The MIT License
 * Copyright (c) 2006 satoshi akabane(akabane@logical-paradox.org)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights 
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
 * copies of the Software, and to permit persons to whom the Software is 
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in 
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
#ifndef __procedures_h__
#define __procedures_h__

#include "bdf2bdb.h"
#include "bdb.h"

/*
 * prototype declarations
 */
int p_startfont(int num_of_tokens, char **tokens, BDB *bdb);
int p_comment(int num_of_tokens, char **tokens, BDB *bdb);
int p_font(int num_of_tokens, char **tokens, BDB *bdb);
int p_size(int num_of_tokens, char **tokens, BDB *bdb);
int p_fontboundingbox(int num_of_tokens, char **tokens, BDB *bdb);
int p_startproperties(int num_of_tokens, char **tokens, BDB *bdb);
int p_fontname_registry(int num_of_tokens, char **tokens, BDB *bdb);
int p_foundry(int num_of_tokens, char **tokens, BDB *bdb);
int p_family_name(int num_of_tokens, char **tokens, BDB *bdb);
int p_weight_name(int num_of_tokens, char **tokens, BDB *bdb);
int p_slant(int num_of_tokens, char **tokens, BDB *bdb);
int p_setwidth_name(int num_of_tokens, char **tokens, BDB *bdb);
int p_add_style_name(int num_of_tokens, char **tokens, BDB *bdb);
int p_pixel_size(int num_of_tokens, char **tokens, BDB *bdb);
int p_point_size(int num_of_tokens, char **tokens, BDB *bdb);
int p_resolution_x(int num_of_tokens, char **tokens, BDB *bdb);
int p_resolution_y(int num_of_tokens, char **tokens, BDB *bdb);
int p_spacing(int num_of_tokens, char **tokens, BDB *bdb);
int p_average_width(int num_of_tokens, char **tokens, BDB *bdb);
int p_charset_registry(int num_of_tokens, char **tokens, BDB *bdb);
int p_charset_encoding(int num_of_tokens, char **tokens, BDB *bdb);
int p_copyright(int num_of_tokens, char **tokens, BDB *bdb);
int p_default_char(int num_of_tokens, char **tokens, BDB *bdb);
int p_font_ascent(int num_of_tokens, char **tokens, BDB *bdb);
int p_font_decent(int num_of_tokens, char **tokens, BDB *bdb);
int p_xmbdfed_info(int num_of_tokens, char **tokens, BDB *bdb);
int p_endproperties(int num_of_tokens, char **tokens, BDB *bdb);
int p_chars(int num_of_tokens, char **tokens, BDB *bdb);
int p_startchar(int num_of_tokens, char **tokens, BDB *bdb);
int p_encoding(int num_of_tokens, char **tokens, BDB *bdb);
int p_swidth(int num_of_tokens, char **tokens, BDB *bdb);
int p_dwidth(int num_of_tokens, char **tokens, BDB *bdb);
int p_bbx(int num_of_tokens, char **tokens, BDB *bdb);
int p_bitmap(int num_of_tokens, char **tokens, BDB *bdb);
int p_endchar(int num_of_tokens, char **tokens, BDB *bdb);
int p_endfont(int num_of_tokens, char **tokens, BDB *bdb);

#endif
